% @author Victoria Steck

:-dynamic guessnum/1.

% The main method that explains the rules
go :-   write('Welcome to Mastermind.'), nl,
        write('Please think of a five digit code using the numbers 1-8. Type yes. when you are ready: '),
        nl, read(yes),
        main.

% This method generates a random guess, asks the user for bulls and cows, calls execute and increases the guess number by 1.
main :- randomNum(1, [], Result),
	retract(guessnum(X)),
	write('Guess number '), write(X),
	A is X + 1, nl, 
	assert(guessnum(A)), 
	write('My guess is '), write(Result), nl,
	write('Please enter the number of bulls followed by a period: '),
        read(Y), nl,
        write('Please enter the number of cows followed by a period: '),
        read(Z), nl,
	execute(Y, Z).

% This method checks to see if we somehow stumbled upon a correct combination or reached the maximum number of guesses.
execute(5, _) :- write('Thanks for playing').
execute(_,_) :- guessnum(13), write('No luck').
execute(_,_) :- main.

% This method uses Prolog's built in random method to generate a number between 0 and 8 and associate that number with a color to generate a guess.
randomNum(6, Guess, Guess).
randomNum(Pos, Guess, Result) :- I is random(8),
				 X is I + 1,
				 Pos2 is Pos + 1,
				 randomNum(Pos2, [X|Guess], Result).

% the current guess number
guessnum(1).

